from machine import Pin
import utime,time
import binascii

led_pin =25  #onboard led
pwr_en = 14  #pin to control the power of sim7020x
uart_port = 0
uart_baute = 115200

ProductKey = "a1IBIPnZU9G"
Broker_Address = ProductKey + ".iot-as-mqtt.cn-shanghai.aliyuncs.com"
DeviceName = "7020"
DeviceSecret = "8e870f4e611d3e4c2b8f9f017e6a88ab"


led_onboard = machine.Pin(led_pin, machine.Pin.OUT)

def led_blink():
    led_onboard.value(1)
    utime.sleep(0.5)
    led_onboard.value(0)
    utime.sleep(0.5)
    led_onboard.value(1)
    utime.sleep(0.5)
    led_onboard.value(0)

def hexStr_to_str(hex_str):
    hex = hex_str.encode('utf-8')
    str_bin = binascii.unhexlify(hex)
    return str_bin.decode('utf-8')

def str_to_hexStr(string):
    str_bin = string.encode('utf-8')
    return binascii.hexlify(str_bin).decode('utf-8')

#power on the sim800c
def powerOn(pwr_en):
    pwr_key = machine.Pin(pwr_en, machine.Pin.OUT)
    pwr_key.value(1)
    
#power down the sim800c
def powerDown(pwr_en):
    pwr_key = machine.Pin(pwr_en, machine.Pin.OUT)
    pwr_key.value(0)
    
def sendCMD_waitRespLine(cmd, timeout=2000):
    print("CMD: " + cmd)
    uart.write((cmd+'\r\n').encode())
    waitRespLine(timeout)
    print()
    
def waitRespLine(timeout=2000):
    global send_data
    prvMills = utime.ticks_ms()
    while (utime.ticks_ms()-prvMills)<timeout:
        if uart.any():
            print((uart.readline()).decode())
  
def waitResp(timeout=2000):
    prvMills = utime.ticks_ms()
    resp = b""
    while (utime.ticks_ms()-prvMills)<timeout:
        if uart.any():
            resp = b"".join([resp, uart.read(1)])
    print((resp).decode())
#AT commands test
def atCommandTest():
    sendCMD_waitRespLine("AT")
    sendCMD_waitRespLine("ATE1")
    sendCMD_waitRespLine("AT+CGMM")
    sendCMD_waitRespLine("AT+CPIN?")        #whether some password is required or not
    sendCMD_waitRespLine("AT+CSQ")          #received signal strength
    sendCMD_waitRespLine("AT+CGREG?")        #the registration of the ME.
    sendCMD_waitRespLine("AT+CGATT?")       #GPRS Service’s status
    sendCMD_waitRespLine("AT+CGACT?")       #PDN active status
    sendCMD_waitRespLine("AT+COPS?")       #Query Network information
    sendCMD_waitRespLine("AT+CGCONTRDP")       #Attached PS domain and got IP address automatically

# MQTT Test
def mqttconnectTest():
    sendCMD_waitRespLine("AT+CMQNEW="+"\""+Broker_Address+"\""+",\"1883\",12000,1024")  #create tcp connection 
    sendCMD_waitRespLine("AT+CMQALICFG=0,\""+ProductKey+"\",\""+DeviceName+"\",\""+DeviceSecret+"\"")     #set device parameters  
    sendCMD_waitRespLine("AT+CMQALICON=0,600,1")     # send MQTT request
    time.sleep(3)  
    sendCMD_waitRespLine("AT+CMQSUB=0,\"/"+ProductKey+"/"+DeviceName+"/"+"user/TEST1\",1")               # subscribe to topics
    time.sleep(3)
    sendCMD_waitRespLine("AT+CMQPUB=0,\"/"+ProductKey+"/"+DeviceName+"/user/TEST1\",1,0,0,16,\"3132333435363738\"")  # release the news
    time.sleep(3)
    sendCMD_waitRespLine("AT+CMQUNSUB=0,\"/"+ProductKey+"/"+DeviceName+"/user/TEST1\"")  # unsubscribe topic
    time.sleep(3)
    sendCMD_waitRespLine("AT+CMQDISCON=0")   # disconnect MQTT connection
#print uart info
uart = machine.UART(uart_port, uart_baute, bits=8, parity=None, stop=1)
print(uart)

#power on the board
powerOn(pwr_en)

#clear bufer in UART
waitResp()

#AT commands test
atCommandTest()
#MQTT test
mqttconnectTest()



#power down the board
powerDown(pwr_en)